.\" $NetBSD: vga.4,v 1.14 2003/05/06 08:42:19 wiz Exp $
.\"
.\" Copyright (c) 1999, 2000
.\" 	Matthias Drochner.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd May 4, 2003
.Dt VGA 4
.Os
.Sh NAME
.Nm vga
.Nd VGA graphics driver for wscons
.Sh SYNOPSIS
.Cd options VGA_CONSOLE_SCREENTYPE="??x??"
.Cd options VGA_CONSOLE_ATI_BROKEN_FONTSEL
.Pp
.Cd "vga0 at isa?"
.Cd "vga* at pci?"
.Cd "wsdisplay* at vga? console ?"
.Sh DESCRIPTION
This driver handles
.Tn VGA
graphics hardware within the
.Xr wscons 4
console framework.
It doesn't provide direct device
driver entry points but makes its functions available via
the internal
.Xr wsdisplay 4
interface.
.Pp
The
.Nm
driver supports text-mode hardware acceleration on the
.Tn VGA
hardware.
Currently, the driver runs the display with a 720\(mu400 pixel resolution.
The
.Tn VGA
text-mode accelerator divides the display into fixed-size
character cells.
The size of the character cells specifies the number of characters available
on the screen and the resolution of the font.
The wsdisplay screen
.Dq types
supported by the
.Nm
driver are described by the number of character cells available
on the screen.
See below for a complete list of supported screen modes in the
.Nm
driver.
.Pp
Each screen mode requires a suitable font to be loaded into
the kernel by the
.Xr wsfontload 8
utility, before the screen can be used.
The size of the font
and the screen mode must match for use on the 720\(mu400 display.
For example, a screen mode with 80 columns and 40 rows requires
a font where each character is 8 pixels wide and 10 pixels high.
The
.Nm
driver can display fonts of the original
.Tn IBM
type and ISO-8859-1 encoded fonts.
A builtin font of 256 characters and 8\(mu16 pixels is always
present on the
.Tn VGA
hardware.
.Pp
The colour
.Tn VGA
hardware supports the display of 16 different colours at the same
time.
It is possible with
.Tn VGA
colour systems to use fonts with 512 characters at any one time.
This is due to the fact that with VGA adapters one can specify an
alternate font to be used instead of bright letters
(used for highlighting on the screen).
As an experimental feature, the
.Dq higher half
fonts of the former
.Nx Ns /i386
.Nm pcvt
driver distribution can be used too if the kernel option
.Dq WSCONS_SUPPORT_PCVTFONTS
was set at compile time.
This is only useful with the
.Dq *bf
screen types; a font containing the
.Tn ASCII
range of characters must be available too on this screen.
.Pp
Currently, the following screen types are supported:
.Bl -hang
.It 80x25
This is the standard
.Tn VGA
text mode with 80 columns and 25 rows.
Sixteen different colors can be displayed at the same time.
Characters are 8\(mu16 pixels, and a font consists of 256 characters.
.It 80x25bf
is a modified version of the previous.
It only allows 8 colors to be displayed.
In exchange, it can access two fonts at the same time, so that
512 different characters can be displayed.
.It 80x40
A text mode with 80 columns and 40 rows.
Similar to the standard mode, 16 colors and 256 characters are
available.
Characters are 8\(mu10 pixels.
For this mode to be useful, a font of that character size must
be downloaded.
.It 80x40bf
is analogously to
.Dq 80x25bf
a version with 512 displayable characters but 8 colors only.
.It 80x50
A text mode with 80 columns and 50 rows.
Similar to the standard mode, 16 colors and 256 characters are
available.
Characters are 8\(mu8 pixels.
For this mode to be useful, a font of that character size must
be downloaded.
.It 80x50bf
is analogously to
.Dq 80x25bf
a version with 512 displayable characters but 8 colors only.
.It 80x24
is a variant of the
.Dq 80x25
screen type which displays 24 lines only.
It uses the standard 8x16 VGA font.
This mode might be useful for applications which depend on closer
.Tn DEC VT100
compatibility.
.It 80x24bf
Analogously, like
.Dq 80x24
but with 512 character slots and 8 colors.
.El
.Pp
If you have an Ati videocard and you are experiencing problems with
fonts other than 80x25, you can try to set
.Cd options VGA_CONSOLE_ATI_BROKEN_FONTSEL
in you kernel configuration and see if it helps.
.Pp
The
.Nm
driver supports multiple virtual screens on one physical
display.
The screens allocated on one display can be of different
.Dq types .
The type is determined at the time the virtual screen is created
and can't be changed later.
Screens are either created at kernel startup
(then the default type is used) or later with help of the
.Xr wsconscfg 8
utility.
.Sh SEE ALSO
.Xr isa 4 ,
.Xr pcdisplay 4 ,
.Xr pci 4 ,
.Xr wscons 4 ,
.Xr wsconscfg 8 ,
.Xr wsfontload 8
.Sh BUGS
Only a subset of the possible text modes is supported.
.Pp
.Tn VGA
cards are supposed to emulate an
.Tn MDA
if a monochrome display is connected.
In this case, the device will naturally not support colors at
all, but offer the capability to display underlined characters
instead.
The
.Dq 80x25bf ,
.Dq 80x40bf ,
.Dq 80x50bf
and
.Dq 80x24bf
screen types will not be available.
This mode of operation has not been tested.
